//---------------------------------------------------------------------------
#ifndef runH
#define runH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <Menus.hpp>
#include <ExtCtrls.hpp>
#include "program.h"

//---------------------------------------------------------------------------
/**/         /*###############################################*/         /**/
//---------------------------------------------------------------------------
#define RResultOK      mrOk
#define RResultCancel  mrAbort
#define RResultError   mrAll

//---------------------------------------------------------------------------
/**/         /*###############################################*/         /**/
//---------------------------------------------------------------------------
class TfRun : public TForm
{
__published:	// IDE-managed Components
        TStatusBar *oStatusBar;
        TMemo *oText;
        TMainMenu *mMainMenu;
        TTimer *oTimer;
        TMenuItem *mClose;
        TMenuItem *mStop;
        TMenuItem *mBreak;
        void __fastcall FormShow(TObject *Sender);
        void __fastcall oTimerTimer(TObject *Sender);
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall FormDestroy(TObject *Sender);
        void __fastcall mCloseClick(TObject *Sender);
        void __fastcall mStopClick(TObject *Sender);
        void __fastcall mBreakClick(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
private:	// User declarations
        PCondition ReadCondition(char ** vStr, char ** vWord);
public:		// User declarations
        __fastcall TfRun(TComponent* Owner);

        int  __fastcall ParseProgram(void);
        void __fastcall Run(void);
        void __fastcall Continue(void);

        int  __fastcall GetWorkingRegisterValue (void);

        TProgram * oProgram;
public:
        int GotoPos;
        int GotoLine;
        int RunAs;
        int AutoStopAtLine;
};
//---------------------------------------------------------------------------
/**/         /*###############################################*/         /**/
//---------------------------------------------------------------------------
extern PACKAGE TfRun *fRun;
//---------------------------------------------------------------------------
#endif
